Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkInstantiator Class Reference

`#include <vtkInstantiator.h>`

Inheritance diagram for vtkInstantiator:

[legend]
Collaboration diagram for vtkInstantiator:

[legend]
List of all members.

## Detailed Description

create an instance of any VTK class from its name.

Date:
  2002/12/26 18:24:21

Revision:
  1.5

vtkInstantiator provides an interface to create an instance of any VTK class from its name. Instances are created through registered pointers to functions returning the objects. New classes can also be registered with the creator. VTK libraries automatically register their classes with the creator when they are loaded. Instances are created using the static New() method, so the normal vtkObjectFactory mechanism is still invoked.

When using this class from language wrappers (Tcl, Python, or Java), the vtkInstantiator should be able to create any class from any kit that has been loaded.

In C++ code, one should include the header for each kit from which one wishes to create instances through vtkInstantiator. This is necessary to ensure proper linking when building static libraries. Be careful, though, because including each kit's header means every class from that kit will be linked into your executable whether or not the class is used. The headers are:

vtkCommon - vtkCommonInstantiator.h vtkFiltering - vtkFilteringInstantiator.h vtkIO - vtkIOInstantiator.h vtkImaging - vtkImagingInstantiator.h vtkGraphics - vtkGraphicsInstantiator.h vtkRendering - vtkRenderingInstantiator.h vtkHybrid - vtkHybridInstantiator.h vtkParallel - vtkParallelInstantiator.h vtkPatented - vtkPatentedInstantiator.h

The VTK_MAKE_INSTANTIATOR() command in CMake is used to automatically generate the creator registration for each VTK library. It can also be used to create registration code for VTK-style user libraries that are linked to vtkCommon. After using this command to register classes from a new library, the generated header must be included.

Created by:
  - King, Brad

CVS contributions (if > 5%):
  - King, Brad (99%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkInstantiator.cxx)`
  - .`h` (`/Common/vtkInstantiator.h)`

Tests:
  vtkInstantiator (Tests)

Definition at line 84 of file vtkInstantiator.h.

## Public Types
typedef vtkObject | Superclass
typedef vtkObject *(* | CreateFunction )()
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
## Static Public Methods
vtkInstantiator * | New ()
int | IsTypeOf (const char *type)
vtkInstantiator * | SafeDownCast (vtkObject *o)
vtkObject * | CreateInstance (const char *className)
void | RegisterInstantiator (const char *className, CreateFunction createFunction)
void | UnRegisterInstantiator (const char *className, CreateFunction createFunction)
## Protected Methods
| vtkInstantiator ()
| ~vtkInstantiator ()
## Static Protected Methods
void | ClassInitialize ()
void | ClassFinalize ()
## Static Protected Attributes
vtkInstantiatorHashTable * | CreatorTable
## Friends
class | vtkInstantiatorInitialize

## Member Typedef Documentation

typedef vtkObject vtkInstantiator::Superclass

| Reimplemented from vtkObject. Definition at line 88 of file vtkInstantiator.h.

typedef vtkObject*(* vtkInstantiator::CreateFunction)()

| Definition at line 96 of file vtkInstantiator.h.

## Constructor & Destructor Documentation

vtkInstantiator::vtkInstantiator | ( |  | ) | `[protected]`

vtkInstantiator::~vtkInstantiator | ( |  | ) | `[protected]`

## Member Function Documentation

vtkInstantiator* vtkInstantiator::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkInstantiator::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkInstantiator::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkInstantiator::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkInstantiator* vtkInstantiator::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkInstantiator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject.

vtkObject* vtkInstantiator::CreateInstance | ( | const char * | className | ) | `[static]`

| Create an instance of the class whose name is given. If creation fails, a NULL pointer is returned.

void vtkInstantiator::RegisterInstantiator | ( | const char * | className,
|  | CreateFunction | createFunction
| ) | `[static]`

| Register a function to create instances of the class whose name is given. This allows more than one create function to be registered for the same class. The first one registered is used until it is unregistered.

void vtkInstantiator::UnRegisterInstantiator | ( | const char * | className,
|  | CreateFunction | createFunction
| ) | `[static]`

| Unregister the instance creation of the class whose name is given. This will unregister the function given, but any other function registered for the same class will be left untouched.

void vtkInstantiator::ClassInitialize | ( |  | ) | `[static, protected]`

void vtkInstantiator::ClassFinalize | ( |  | ) | `[static, protected]`

## Friends And Related Function Documentation

friend class vtkInstantiatorInitialize`[friend]`

| Definition at line 127 of file vtkInstantiator.h.

## Member Data Documentation

vtkInstantiatorHashTable* vtkInstantiator::CreatorTable`[static, protected]`

| Definition at line 121 of file vtkInstantiator.h.

The documentation for this class was generated from the following file:

- Common/vtkInstantiator.h